defaultpen(fontsize(10 pt));
settings.outformat="png";
settings.render=10;
settings.tex="xelatex";
import smoothcontour3;
import graph3; import grid3; import three; import tube;
import animate; import labelpath3;
texpreamble("\usepackage{fourier}");
size(8cm,0);
currentprojection=perspective((4,5,4));
currentlight=light(white,specularfactor=2,(1,1,2));

pen rose = cmyk(0,1,.65,.28);
pen roseblue = cmyk(.40,.16,.01,.02);
pen roseyellow=cmyk(.02,.05,.53,.05);
pen rosebrown=cmyk(.16,.32,1.00,.61);
pen roseorange=cmyk(0,0.64,0.95,0);
pen rosenavy=cmyk(.71,.30,.13,.41);
pen rosewhite=cmyk(.03,.05,.26,.02);

path3 p=(4,0,1)..(2,1,3)..(3,3,2)..(0,3,2);
path3 q;

int l=length(p);
for(int i=0; i<6;++i) {
    triple a=point(p,i*l/5);
    q=q--a;
    }

dot(point(p,0),rosenavy,L=Label("$\mathbf{r}(t_0)$",align=S));
dot(point(p,l/5),rosenavy,L=Label("$\mathbf{r}(t_1)$",align=N));
dot(point(p,2l/5),rosenavy,L=Label("$\mathbf{r}(t_2)$",align=E));
dot(point(p,3l/5),rosenavy,L=Label("$\mathbf{r}(t_3)$",align=W));
dot(point(p,4l/5),rosenavy,L=Label("$\mathbf{r}(t_4)$",align=S));
dot(point(p,l),rosenavy,L=Label("$\mathbf{r}(t_5)$",align=N));

draw(tube(p,scale(0.025)*unitcircle),roseorange+opacity(0.5));
draw(tube(q,scale(0.025)*unitsquare),rosenavy);

xaxis3("$x$",0,4,OutTicks(4,4),Arrow3);
yaxis3("$y$",0,4,OutTicks(),Arrow3);
zaxis3("$z$",0,3,OutTicks(),Arrow3);


