import texsettings;
import graph3; 
import patterns;
size(7cm,0);
currentprojection=perspective(4,4,2);
currentlight=light(white,
                  specularfactor=2,
                   (2,1,1),(6,7,0));



transform3 cus(triple a, triple b, triple c)
{
  transform3 t=identity(4);
  
  t[0][0]=a.x/length(a);
  t[0][1]=b.x/length(b);
  t[0][2]=c.x/length(c);
  t[1][0]=a.y/length(a);
  t[1][1]=b.y/length(b);
  t[1][2]=c.y/length(c);
  t[2][0]=a.z/length(a);
  t[2][1]=b.z/length(b);
  t[2][2]=c.z/length(c);
  return t;
}

triple s(pair uv) {
    real x=uv.x; real y=uv.y;
    return (x,
            y,
            1-sin(y)/2+exp(-x));
}
triple pl(pair uv) {
    real x=uv.x; real y=uv.y;
    return (x,
            y,
            0);
}

splinetype[] Notaknot={notaknot,notaknot,notaknot};

surface surf=surface(
    s,(0,0),(1.1,2), nu=11, nv=20,Notaknot,Notaknot);
surface plan=surface(
    pl,(0,0),(2,2),nu=20, nv=1,Notaknot,Notaknot);

real delta=0.1;

real f(real x, real y){
    return 1-sin(y)/2+exp(-x);
}

int i=5;
real a=0.5+i*delta;
triple sideA(pair uv){
    real v=uv.x; real y=uv.y;
        return (a,
                y,
                v*f(a,y));
}
triple sideB(pair uv){
    real v=uv.x; real y=uv.y;
        return (a+delta,
                y,
                v*f(a,y));
}
triple top(pair uv){
    real h=uv.x; real y=uv.y;
        return (a+h*0.1,
                y,
                f(a,y));
}
triple edge(pair uv){
    real h=uv.x; real v=uv.y;
        return (a+delta*h,
                2,
                v*f(a,2));
}


surface strip=surface(top,(0,0),(1,2),nu=1,nv=20,Notaknot,Notaknot);
surface sA=surface(sideA,(0,0),(1,2),nu=1,nv=20,Notaknot,Notaknot);
surface sB=surface(sideB,(0,0),(1,2),nu=1,nv=20,Notaknot,Notaknot);
surface ed=surface(edge,(0,0),(1,1),nu=1,nv=1,Notaknot,Notaknot);
draw(strip,surfacepen=rose);
draw(sA,surfacepen=rosewhite);
add("crosshatch",crosshatch(3mm));
draw(sB,surfacepen=roseblue*0.25);
draw(ed,surfacepen=roseorange*0.5,black+0.2);


triple v = (0,0,1);
triple u = (0,1,0);
triple n = (1,0,0);
label(scale3(1)*cus(u,v,n)*"plate area $=\displaystyle \int_c^d f(x_i,y)\ \mathrm{d}y$",(1.11,1,0.5),rosenavy,Embedded);
triple uu=(-1,0,0);
triple vv=(0,0,1);
triple nn=(0,1,0);
label(scale3(1)*cus(uu,vv,nn)*"$\overbrace{\text{thickness of $\Delta x$}}$",(1,2,-0.15),roseorange,Embedded);
label(scale3(1)*cus(u,v,n)*"$x=x_i$",(1.11,1,0.05),rosenavy,Embedded);

draw(surf,surfacepen=white+opacity(0.2),meshpen=black+0.2+opacity(0.2));
draw(plan,surfacepen=white+opacity(0.0),meshpen=black+0.2);

xaxis3("$x$",Arrow3);
yaxis3("$y$",Arrow3);
zaxis3("$z$",Arrow3);
