defaultpen(fontsize(10 pt));
settings.outformat="pdf";
settings.render=0;
settings.tex="xelatex";
settings.prc=false;
import smoothcontour3;
import graph3; import grid3; import three; import tube;
import animate; import labelpath3; import contour; import palette; import graph;

size(8cm,0);

pen rose = cmyk(0,1,.65,.28);
pen roseblue = cmyk(.40,.16,.01,.02);
pen roseyellow=cmyk(.02,.05,.53,.05);
pen rosebrown=cmyk(.16,.32,1.00,.61);
pen roseorange=cmyk(0,0.64,0.95,0);
pen rosenavy=cmyk(.71,.30,.13,.41);
pen rosewhite=cmyk(.03,.05,.26,.02);
pen rosegreen=cmyk(0.49,0.27,0.98,0.79);

real f(real x, real y){
    return 3^(-(x^2+(y+3)^2)/5+1)+2^(-(x+1)^2-(y-2)^2+1)+2^(-(x-2)^2-(y-2)^2+2);
}

real fx(real x, real y){
    return log(3)*3^(-(x^2+(y+3)^2)/5+1)*(-2x/5) +
    	log(2)*2^(-(x+1)^2-(y-2)^2+1)*(-2(x+1)) + 
    		log(2)*2^(-(x-2)^2-(y-2)^2+2)*(-2(x-2));
}

real fy(real x, real y){
    return log(3)*3^(-(x^2+(y+3)^2)/5+1)*(-2(y+3)/5) +
    	log(2)*2^(-(x+1)^2-(y-2)^2+1)*(-2(y-2)) + 
    		log(2)*2^(-(x-2)^2-(y-2)^2+2)*(-2(y-2));
}

real g(real x, real y){
	return exp(-2*(x+1)^2-(y+1)^2)+exp(-(x-1)^2-(y-1)^2);
}

real gx(real x, real y){
	return exp(-2*(x+1)^2-(y+1)^2)*(-4(x+1)) + 
		exp(-(x-1)^2-(y-1)^2)*(-2(x-1));
}

real gy(real x, real y){
	return exp(-2*(x+1)^2-(y+1)^2)*(-2(y+1)) + 
		exp(-(x-1)^2-(y-1)^2)*(-2(y-1));
}

pair gradf(real x, real y){
  return (fx(x,y),fy(x,y));
}

pair gradg(real x, real y){
	return(gx(x,y),gy(x,y));
}


pen[] pens=Gradient(rosenavy,roseblue,roseyellow,roseorange,rose);

bounds range=image(f,Automatic,(-4,-4),(4,4),300,pens);

//real[] Cvals=uniform(range.min,range.max,10);

real[] gvals={0.05};
real[] fvals={3.7347,0.65023,0.90093,0.20207,2.74669,0.310387};

draw(contour(g,(-4,-4),(4,4),gvals,300,operator--),darkgray+dashed);
//draw(contour(f,(-4,-4),(4,4),fvals,300,operator--),darkgray);

xaxis("$x$",BottomTop,LeftTicks,above=true);
yaxis("$y$",LeftRight,RightTicks,above=true);

guide[][] pl=contour(g,(-4,-4),(4,4),gvals);

int l=length(pl[0][0]);
animation A;
for(int i=0;i<l/5;++i){
save();
pair base=point(pl[0][0],5*i);
dot(base,roseorange);
draw(base--base+3gradg(base.x,base.y),
darkgray+0.75,
Arrow(TeXHead),
L=Label("$\nabla g$",position=EndPoint));
draw(base--base+gradf(base.x,base.y),
darkgray+0.75,
Arrow(TeXHead),
L=Label("$\nabla f$",position=EndPoint));
A.add();
restore();
}
A.export();
