defaultpen(fontsize(10 pt));
import contour; import graph;
texpreamble("\usepackage{fourier}");
pen roseorange=cmyk(0,0.64,0.95,0);
size(8cm,7cm,IgnoreAspect);
real f(real x){return(sin(x^2));}
real F(real x){
    return simpson(f,0,x);
}
ylimits(0,1);
xlimits(0,7);
path G=graph(F,0,2pi,n=200);
draw(G,roseorange+0.75,
    legend=Label("$\displaystyle 
    F(x)=\int_0^x \sin(t^2)\
    \mathrm{d}t$"));
xaxis("$x$",BottomTop,LeftTicks);
yaxis("$y$",LeftRight,RightTicks);
attach(scale(0.9)*legend(),
    point(SE),10N+10W,UnFill);

