defaultpen(fontsize(10 pt));
settings.outformat="png";
settings.render=10;
settings.tex="xelatex";
import smoothcontour3;
import graph3; 
//import animate; import labelpath3; import contour; import
//palette; import grid3; import three; import tube;
texpreamble("\usepackage{fourier}");
size(8cm,0);
currentprojection=perspective(3,5,3);
currentlight=light(lightgray,
                  specularfactor=1,
                   (2,2,0),(0,0,3));

pen rose = cmyk(0,1,.65,.28);
pen roseblue = cmyk(.40,.16,.01,.02);
pen roseyellow=cmyk(.02,.05,.53,.05);
pen rosebrown=cmyk(.16,.32,1.00,.61);
pen roseorange=cmyk(0,0.64,0.95,0);
pen rosenavy=cmyk(.71,.30,.13,.41);
pen rosewhite=cmyk(.03,.05,.26,.02);
pen rosegreen=cmyk(0.49,0.27,0.98,0.79);

splinetype[] Notaknot={notaknot,notaknot,notaknot};
real r(real t){return 
1/sqrt(1+cos(t)*sin(t));
}
triple s(pair uv){
real t=uv.x; real h=uv.y;
return (h*r(t)*cos(t),
        h*r(t)*sin(t),
        h*r(t));
}
triple c(pair uv){
real t=uv.x; real h=uv.y;
return (r(t)*cos(t),
        r(t)*sin(t),
        h*r(t));
}
triple f(real t){
    return (r(t)*cos(t),
            r(t)*sin(t),
            0);
} 
triple g(real t){
    return (s((t,1)).x,
            s((t,1)).y,
            s((t,1)).z);
}
path3 p=graph(f,0,2pi,operator..);
path3 q=graph(g,0,2pi,operator..);
surface cyl=
    surface(c,
        (0,0),
        (2pi,1),
        nu=20,nv=20,
        Spline);
surface surf=
    surface(s,
    (0,0),
    (2pi,1),
    nu=20,nv=20,
    Spline);
draw(surf,roseorange);
draw(cyl,rosewhite+opacity(0.35));
draw(p,black+dashed);
draw(q,darkgray+0.5);

xaxis3("$x$",-2,2,OutTicks(4,4),Arrow3);
yaxis3("$y$",-2,2,OutTicks(4,4),Arrow3);
zaxis3("$z$",0,2,OutTicks(2,2),Arrow3);

